searchData={"items":[{"type":"module","title":"MyXQL","doc":"MySQL driver for Elixir.","ref":"MyXQL.html"},{"type":"function","title":"MyXQL.child_spec/1","doc":"Returns a supervisor child specification for a DBConnection pool.","ref":"MyXQL.html#child_spec/1"},{"type":"function","title":"MyXQL.close/3","doc":"Closes a prepared query.\n\nReturns `:ok` on success, or raises an exception if there was an error.","ref":"MyXQL.html#close/3"},{"type":"function","title":"Options - MyXQL.close/3","doc":"Options are passed to `DBConnection.close/3`, see it's documentation for\nall available options.","ref":"MyXQL.html#close/3-options"},{"type":"function","title":"MyXQL.execute/4","doc":"Executes a prepared query that returns a single result.","ref":"MyXQL.html#execute/4"},{"type":"function","title":"Options - MyXQL.execute/4","doc":"Options are passed to `DBConnection.execute/4`, see it's documentation for\nall available options.","ref":"MyXQL.html#execute/4-options"},{"type":"function","title":"Examples - MyXQL.execute/4","doc":"iex> {:ok, query} = MyXQL.prepare(conn, \"\", \"SELECT ? * ?\")\n    iex> {:ok, %MyXQL.Result{rows: [row]}} = MyXQL.execute(conn, query, [2, 3])\n    iex> row\n    [6]","ref":"MyXQL.html#execute/4-examples"},{"type":"function","title":"MyXQL.execute!/4","doc":"Executes a prepared query that returns a single result.\n\nReturns `%MyXQL.Result{}` on success, or raises an exception if there was an error.\n\nSee: `execute/4`.","ref":"MyXQL.html#execute!/4"},{"type":"function","title":"MyXQL.execute_many/4","doc":"Executes a prepared query that returns multiple results.","ref":"MyXQL.html#execute_many/4"},{"type":"function","title":"Options - MyXQL.execute_many/4","doc":"Options are passed to `DBConnection.execute/4`, see it's documentation for\nall available options.","ref":"MyXQL.html#execute_many/4-options"},{"type":"function","title":"Examples - MyXQL.execute_many/4","doc":"iex> {:ok, query} = MyXQL.prepare_many(conn, \"\", \"CALL multi_procedure()\")\n    iex> {:ok, [%MyXQL.Result{rows: [row1]}, %MyXQL.Result{rows: [row2]}]} = MyXQL.execute_many(conn, query)\n    iex> row1\n    [2]\n    iex> row2\n    [3]","ref":"MyXQL.html#execute_many/4-examples"},{"type":"function","title":"MyXQL.execute_many!/4","doc":"Executes a prepared query that returns multiple results.\n\nReturns `[%MyXQL.Result{}]` on success, or raises an exception if there was an error.\n\nSee: `execute_many/4`.","ref":"MyXQL.html#execute_many!/4"},{"type":"function","title":"MyXQL.json_library/0","doc":"Returns the configured JSON library.\n\nTo customize the JSON library, include the following in your `config/config.exs`:\n\n    config :myxql, json_library: SomeJSONModule\n\nDefaults to `Jason`.","ref":"MyXQL.html#json_library/0"},{"type":"function","title":"MyXQL.prepare/4","doc":"Prepares a query that returns a single result to be later executed.\n\nTo execute the query, call `execute/4`. To close the query, call `close/3`.\nIf a name is given, the name must be unique per query, as the name is cached\nbut the statement isn't. If a new statement is given to an old name, the old\nstatement will be the one effectively used.","ref":"MyXQL.html#prepare/4"},{"type":"function","title":"Options - MyXQL.prepare/4","doc":"Options are passed to `DBConnection.prepare/3`, see it's documentation for\nall available options.","ref":"MyXQL.html#prepare/4-options"},{"type":"function","title":"Examples - MyXQL.prepare/4","doc":"iex> {:ok, query} = MyXQL.prepare(conn, \"\", \"SELECT ? * ?\")\n    iex> {:ok, %MyXQL.Result{rows: [row]}} = MyXQL.execute(conn, query, [2, 3])\n    iex> row\n    [6]","ref":"MyXQL.html#prepare/4-examples"},{"type":"function","title":"MyXQL.prepare!/4","doc":"Prepares a query that returns a single result.\n\nReturns `%MyXQL.Query{}` on success, or raises an exception if there was an error.\n\nSee `prepare/4`.","ref":"MyXQL.html#prepare!/4"},{"type":"function","title":"MyXQL.prepare_execute/5","doc":"Prepares and executes a query that returns a single result, in a single step.","ref":"MyXQL.html#prepare_execute/5"},{"type":"function","title":"Options - MyXQL.prepare_execute/5","doc":"Options are passed to `DBConnection.prepare_execute/4`, see it's documentation for\nall available options.","ref":"MyXQL.html#prepare_execute/5-options"},{"type":"function","title":"Examples - MyXQL.prepare_execute/5","doc":"iex> {:ok, _query, %MyXQL.Result{rows: [row]}} = MyXQL.prepare_execute(conn, \"\", \"SELECT ? * ?\", [2, 3])\n    iex> row\n    [6]","ref":"MyXQL.html#prepare_execute/5-examples"},{"type":"function","title":"MyXQL.prepare_execute!/5","doc":"Prepares and executes a query that returns a single result, in a single step.\n\nReturns `{%MyXQL.Query{}, %MyXQL.Result{}}` on success, or raises an exception if there was\nan error.\n\nSee: `prepare_execute/5`.","ref":"MyXQL.html#prepare_execute!/5"},{"type":"function","title":"MyXQL.prepare_execute_many/5","doc":"Prepares and executes a query that returns multiple results, in a single step.\n\nA prepared statement may return multiple results if it is a stored procedure.\nAny other type of prepared statement is not allowed to return multiple results\nand will return an error.","ref":"MyXQL.html#prepare_execute_many/5"},{"type":"function","title":"Options - MyXQL.prepare_execute_many/5","doc":"Options are passed to `DBConnection.prepare_execute/4`, see it's documentation for\nall available options.","ref":"MyXQL.html#prepare_execute_many/5-options"},{"type":"function","title":"Examples - MyXQL.prepare_execute_many/5","doc":"iex> {:ok, _, [%MyXQL.Result{rows: [row1]}, %MyXQL.Result{rows: [row2]}]} = MyXQL.prepare_execute(conn, \"\", \"CALL multi_procedure()\")\n    iex> row1\n    [2]\n    iex> row2\n    [3]","ref":"MyXQL.html#prepare_execute_many/5-examples"},{"type":"function","title":"MyXQL.prepare_execute_many!/5","doc":"Prepares and executes a query that returns multiple results, in a single step.\n\nReturns `{%MyXQL.Queries{}, [%MyXQL.Result{}]}` on success, or raises an exception if there was\nan error.\n\nSee: `prepare_execute_many/5`.","ref":"MyXQL.html#prepare_execute_many!/5"},{"type":"function","title":"MyXQL.prepare_many/4","doc":"Prepares a query that returns multiple results to be later executed.\n\nA prepared statement may return multiple results if it is a stored procedure.\nAny other type of prepared statement is not allowed to return multiple results\nand will return an error.\n\nTo execute the query, call `execute_many/4`. To close the query, call `close/3`.\nIf a name is given, the name must be unique per query, as the name is cached.\nIf a new statement uses an old name, the old statement will be closed.","ref":"MyXQL.html#prepare_many/4"},{"type":"function","title":"Options - MyXQL.prepare_many/4","doc":"Options are passed to `DBConnection.prepare/3`, see it's documentation for\nall available options.","ref":"MyXQL.html#prepare_many/4-options"},{"type":"function","title":"Examples - MyXQL.prepare_many/4","doc":"iex> {:ok, query} = MyXQL.prepare_many(conn, \"\", \"CALL multi_procedure()\")\n    iex> {:ok, [%MyXQL.Result{rows: [row1]}, %MyXQL.Result{rows: [row2]}]} = MyXQL.execute_many(conn, query, [2, 3])\n    iex> row1\n    [2]\n    iex> row2\n    [3]","ref":"MyXQL.html#prepare_many/4-examples"},{"type":"function","title":"MyXQL.prepare_many!/4","doc":"Prepares a query that returns multiple results.\n\nReturns `%MyXQL.Queries{}` on success, or raises an exception if there was an error.\n\nSee `prepare_many/4`.","ref":"MyXQL.html#prepare_many!/4"},{"type":"function","title":"MyXQL.query/4","doc":"Runs a query that returns a single result.","ref":"MyXQL.html#query/4"},{"type":"function","title":"Text queries and prepared statements - MyXQL.query/4","doc":"MyXQL supports MySQL's two ways of executing queries:\n\n  * text protocol - queries are sent as text\n\n  * binary protocol - used by prepared statements\n\n    The query statement is still sent as text, however it may contain placeholders for parameter\n    values.\n\n    Prepared statements have following benefits:\n\n      * better performance: less overhead when parsing the query by the DB engine\n      * better performance: binary protocol for encoding parameters and decoding result sets is more efficient\n      * protection against SQL injection attacks\n\n    The drawbacks of prepared statements are:\n\n      * not all statements are preparable\n      * requires two roundtrips to the DB server: one for preparing the statement and one for executing it.\n        This can be alleviated by holding on to prepared statement and executing it multiple times.","ref":"MyXQL.html#query/4-text-queries-and-prepared-statements"},{"type":"function","title":"Options - MyXQL.query/4","doc":"* `:query_type` - use `:binary` for binary protocol (prepared statements), `:binary_then_text` to attempt\n    executing a binary query and if that fails fallback to executing a text query, and `:text` for text protocol\n    (default: `:binary`)\n\n  * `:cache_statement` - caches the query with the given name. Opposite to the `name` option\n    given to `prepare/4`, if the cache statement name is reused with a different, the previous\n    query is automatically closed\n\nOptions are passed to `DBConnection.execute/4` for text protocol, and\n`DBConnection.prepare_execute/4` for binary protocol. See their documentation for all available\noptions.","ref":"MyXQL.html#query/4-options"},{"type":"function","title":"Examples - MyXQL.query/4","doc":"iex> MyXQL.query(conn, \"CREATE TABLE posts (id serial, title text)\")\n    {:ok, %MyXQL.Result{}}\n\n    iex> MyXQL.query(conn, \"INSERT INTO posts (title) VALUES ('title 1')\")\n    {:ok, %MyXQL.Result{last_insert_id: 1, num_rows: 1}}\n\n    iex> MyXQL.query(conn, \"INSERT INTO posts (title) VALUES (?)\", [\"title 2\"])\n    {:ok, %MyXQL.Result{last_insert_id: 2, num_rows: 1}}","ref":"MyXQL.html#query/4-examples"},{"type":"function","title":"MyXQL.query!/4","doc":"Runs a query that returns a single result.\n\nReturns `%MyXQL.Result{}` on success, or raises an exception if there was an error.\n\nSee `query/4`.","ref":"MyXQL.html#query!/4"},{"type":"function","title":"MyXQL.query_many/4","doc":"Runs a query that returns multiple results.\n\nA query may return multiple results if it is a text\nquery with statements separated by semicolons or a stored\nprocedure. Any prepared statement that is not a stored\nprocedure is not allowed to return multiple results and will\nreturn an error.\n\nFor more information on text queries and prepared statements,\nsee `query/4`.","ref":"MyXQL.html#query_many/4"},{"type":"function","title":"Options - MyXQL.query_many/4","doc":"* `:query_type` - Use `:binary` for binary protocol (prepared statements), `:binary_then_text` to attempt\n    executing a binary query and if that fails fallback to executing a text query, and `:text` for text protocol\n    (default: `:binary`).\n\n  * `:cache_statement` - Caches the query with the given name. If the cache statement\n    name is reused with a different statement, the previous query is automatically closed.\n\nOptions are passed to `DBConnection.execute/4` for text protocol, and\n`DBConnection.prepare_execute/4` for binary protocol. See their documentation for all available\noptions.","ref":"MyXQL.html#query_many/4-options"},{"type":"function","title":"Examples - MyXQL.query_many/4","doc":"iex> MyXQL.query_many(conn, \"SELECT 1; SELECT 2;\", [], query_type: :text)\n    {:ok, [%MyXQL.Result{rows: [[1]]}, %MyXQL.Result{rows: [[2]]}]}","ref":"MyXQL.html#query_many/4-examples"},{"type":"function","title":"MyXQL.query_many!/4","doc":"Runs a query that returns multiple results.\n\nReturns `[%MyXQL.Result{}]` on success, or raises an exception if there was an error.\n\nSee `query_many/4`.","ref":"MyXQL.html#query_many!/4"},{"type":"function","title":"MyXQL.rollback/2","doc":"Rollback a transaction, does not return.\n\nAborts the current transaction. If inside multiple `transaction/3`\nfunctions, bubbles up to the top level.","ref":"MyXQL.html#rollback/2"},{"type":"function","title":"Example - MyXQL.rollback/2","doc":"{:error, :oops} =\n      MyXQL.transaction(pid, fn conn  ->\n        MyXQL.rollback(conn, :oops)\n        IO.puts \"never reaches here!\"\n      end)","ref":"MyXQL.html#rollback/2-example"},{"type":"function","title":"MyXQL.start_link/1","doc":"Starts the connection process and connects to a MySQL server.","ref":"MyXQL.html#start_link/1"},{"type":"function","title":"Options - MyXQL.start_link/1","doc":"* `:protocol` - Set to `:socket` for using UNIX domain socket, or `:tcp` for TCP\n    (default: `:socket`)\n\n    Connecting using UNIX domain socket is the preferred method. If `:hostname` or `:port` is\n    set, protocol defaults to `:tcp` unless `:socket` is set too.\n\n  * `:socket` - Connect to MySQL via UNIX domain socket in the given path\n    (default: `MYSQL_UNIX_PORT` env variable, then `\"/tmp/mysql.sock\"`)\n\n  * `:socket_options` - Options to be given to the underlying socket, applies to both TCP and\n    UNIX sockets. See `:gen_tcp.connect/3` for more information.  (default: `[]`)\n\n  * `:hostname` - Server hostname (default: `MYSQL_HOST` env variable, then `\"localhost\"`)\n\n  * `:port` - Server port (default: `MYSQL_TCP_PORT` env variable, then `3306`)\n\n  * `:database` - Database (default: `nil`)\n\n  * `:username` - Username (default: `USER` env variable)\n\n  * `:password` - Password (default: `MYSQL_PWD` env variable, then `nil`)\n\n  * `:charset` - A connection charset. On connection handshake, the charset is set to `utf8mb4`,\n    but if this option is set, an additional `SET NAMES   [COLLATE  ]` query\n    will be executed after establishing the connection. `COLLATE` will be added if `:collation`\n    is set. (default: `nil`)\n\n  * `:collation` - A connection collation. Must be given with `:charset` option, and if set\n    it overwrites the default collation for the given charset. (default: `nil`)\n\n  * `:ssl` - Set to `true` if SSL should be used (default: `false`)\n\n  * `:ssl_opts` - A list of SSL options, see `:ssl.connect/2` (default: `[]`)\n\n  * `:connect_timeout` - Socket connect timeout in milliseconds (default:\n    `15_000`)\n\n  * `:handshake_timeout` - Connection handshake timeout in milliseconds (default: `15_000`)\n\n  * `:ping_timeout` - Socket receive timeout when idle in milliseconds (default:\n    `15_000`). See `c:DBConnection.ping/1` for more information\n\n  * `:prepare` - How to cache prepared queries. Queries can be named or unnamed. Named\n    queries are cached, unnamed queries are never cache by default. The possible values\n    for this option are:\n\n      * `:named` - cache only named queries\n      * `:unnamed` - treat all queries as unnamed (i.e. nothing is ever cached)\n      * `:force_named` - treat all queries as named (i.e. everything is cached)\n\n    Note that MySQL has a global limit on the number of prepared queries. So if you\n    enable `:force_named` in production, you may cache more queries than allowed by\n    MySQL, leading to disconnections and user errors. Use `:force_named` only in a\n    controlled environment, such as `:test`, and in `:prod` only if you are monitoring\n    the prepare statement count of your databases (such as using a dashboard or\n    setting alarm handlers)\n\n  * `:disconnect_on_error_codes` - List of error code integers or atoms that when encountered\n    will disconnect the connection. See \"Disconnecting on Errors\" section below for more\n    information.\n\n The given options are passed down to DBConnection, some of the most commonly used ones are\n documented below:\n\n  * `:after_connect` - A function to run after the connection has been established, either a\n    1-arity fun, a `{module, function, args}` tuple, or `nil` (default: `nil`)\n\n  * `:pool` - The pool module to use, defaults to built-in pool provided by DBconnection\n\n  * `:pool_size` - The size of the pool\n\nSee `DBConnection.start_link/2` for more information and a full list of available options.","ref":"MyXQL.html#start_link/1-options"},{"type":"function","title":"Examples - MyXQL.start_link/1","doc":"Start connection using the default configuration (UNIX domain socket):\n\n    iex> {:ok, pid} = MyXQL.start_link([])\n    {:ok, #PID }\n\nStart connection over TCP:\n\n    iex> {:ok, pid} = MyXQL.start_link(protocol: :tcp)\n    {:ok, #PID }\n\nRun a query after connection has been established:\n\n    iex> {:ok, pid} = MyXQL.start_link(after_connect: &MyXQL.query!(&1, \"SET time_zone = '+00:00'\"))\n    {:ok, #PID }","ref":"MyXQL.html#start_link/1-examples"},{"type":"function","title":"Disconnecting on errors - MyXQL.start_link/1","doc":"Sometimes the connection becomes unusable. For example, services such as AWS Aurora support\nfailover which means the database you are currently connected to may suddenly become\nread-only. An attempt to do any write operation, such as INSERT/UPDATE/DELETE will lead to\nerrors such as:\n\n    ** (MyXQL.Error) (1792) (ER_CANT_EXECUTE_IN_READ_ONLY_TRANSACTION) Cannot execute statement in a READ ONLY transaction.\n\nLuckily, you can instruct MyXQL to disconnect in such cases by using the following configuration:\n\n    disconnect_on_error_codes: [:ER_CANT_EXECUTE_IN_READ_ONLY_TRANSACTION]\n\nThis cause the connection process to attempt to reconnect according to the backoff configuration.\n\nMyXQL automatically disconnects the connection on the following error codes and they don't have\nto be configured:\n\n  * `:ER_MAX_PREPARED_STMT_COUNT_REACHED`\n\nYou can pass error codes as integers too:\n\n    disconnect_on_error_codes: [1792]","ref":"MyXQL.html#start_link/1-disconnecting-on-errors"},{"type":"function","title":"Error codes - MyXQL.start_link/1","doc":"MyXQL maintains a mapping of integers/atoms for commonly used errors. You can add additional\nones by adding the following compile-time configuration:\n\n    config :myxql, :extra_error_codes, [\n      {1048, :ER_BAD_NULL_ERROR}\n    ]\n\nAfter adding the configuration, MyXQL needs to be recompiled. It can be done with:\n\n    $ mix deps.clean myxql --build\n\nTo convert error code integers to names you can use `perror` command-line utility that ships\nwith MySQL client installation, e.g.:\n\n    bash$ perror 1792\n    MySQL error code 1792 (ER_CANT_EXECUTE_IN_READ_ONLY_TRANSACTION): Cannot execute statement in a READ ONLY transaction.","ref":"MyXQL.html#start_link/1-error-codes"},{"type":"function","title":"MyXQL.stream/4","doc":"Returns a stream for a query on a connection.\n\nStream consumes memory in chunks of at most `max_rows` rows (see Options).\nThis is useful for processing _large_ datasets.\n\nA stream must be wrapped in a transaction and may be used as an `Enumerable`.","ref":"MyXQL.html#stream/4"},{"type":"function","title":"Options - MyXQL.stream/4","doc":"* `:max_rows` - Maximum numbers of rows in a result (default: `500`)\n\nOptions are passed to `DBConnection.stream/4`, see it's documentation for\nother available options.","ref":"MyXQL.html#stream/4-options"},{"type":"function","title":"Examples - MyXQL.stream/4","doc":"{:ok, results} =\n      MyXQL.transaction(pid, fn conn ->\n        stream = MyXQL.stream(conn, \"SELECT * FROM integers\", [], max_rows: max_rows)\n        Enum.to_list(stream)\n      end)\n\nSuppose the `integers` table contains rows: 1, 2, 3, 4 and `max_rows` is set to `2`.\nWe'll get following results:\n\n    # The first item is result of executing the query and has no rows data\n    Enum.at(results, 0)\n    #=> %MyXQL.Result{num_rows: 0, ...}\n\n    # The second item is result of fetching rows 1 & 2\n    Enum.at(results, 1)\n    #=> %MyXQL.Result{num_rows: 2, rows: [[1], [2]]}\n\n    # The third item is result of fetching rows 3 & 4\n    Enum.at(results, 2)\n    #=> %MyXQL.Result{num_rows: 2, rows: [[3], [4]]}\n\nBecause the total number of fetched rows happens to be divisible by our chosen `max_rows`,\nthere might be more data on the server so another fetch attempt is made.\nBecause in this case there weren't any more rows, the final result has 0 rows:\n\n    Enum.at(results, 3)\n    #=> %MyXQL.Result{num_rows: 0}\n\nHowever, if the table contained only 3 rows, the 3rd result would contain:\n\n    Enum.at(results, 2)\n    #=> %MyXQL.Result{num_rows: 1, rows: [[3]]}\n\nAnd that would be the last result in the stream.","ref":"MyXQL.html#stream/4-examples"},{"type":"function","title":"MyXQL.transaction/3","doc":"Acquire a lock on a connection and run a series of requests inside a\ntransaction. The result of the transaction fun is return inside an `:ok`\ntuple: `{:ok, result}`.\n\nTo use the locked connection call the request with the connection\nreference passed as the single argument to the `fun`. If the\nconnection disconnects all future calls using that connection\nreference will fail.\n\n`rollback/2` rolls back the transaction and causes the function to\nreturn `{:error, reason}`.\n\n`transaction/3` can be nested multiple times if the connection\nreference is used to start a nested transaction. The top level\ntransaction function is the actual transaction.","ref":"MyXQL.html#transaction/3"},{"type":"function","title":"Options - MyXQL.transaction/3","doc":"Options are passed to `DBConnection.transaction/3`, see it's documentation for\nall available options.","ref":"MyXQL.html#transaction/3-options"},{"type":"function","title":"Examples - MyXQL.transaction/3","doc":"{:ok, result} =\n      MyXQL.transaction(pid, fn conn  ->\n        MyXQL.query!(conn, \"SELECT title FROM posts\")\n      end)","ref":"MyXQL.html#transaction/3-examples"},{"type":"type","title":"MyXQL.conn/0","doc":"","ref":"MyXQL.html#t:conn/0"},{"type":"type","title":"MyXQL.option/0","doc":"","ref":"MyXQL.html#t:option/0"},{"type":"type","title":"MyXQL.query_option/0","doc":"","ref":"MyXQL.html#t:query_option/0"},{"type":"type","title":"MyXQL.start_option/0","doc":"","ref":"MyXQL.html#t:start_option/0"},{"type":"type","title":"MyXQL.stream_option/0","doc":"","ref":"MyXQL.html#t:stream_option/0"},{"type":"module","title":"MyXQL.Queries","doc":"A struct for a prepared statement that returns multiple results.\n\nAn example use case is a stored procedure with multiple `SELECT`\nstatements.\n\nIts public fields are:\n\n  * `:name` - The name of the prepared statement;\n  * `:num_params` - The number of parameter placeholders;\n  * `:statement` - The prepared statement","ref":"MyXQL.Queries.html"},{"type":"module","title":"Named and Unnamed Queries - MyXQL.Queries","doc":"Named queries are identified by the non-empty value in `:name` field\nand are meant to be re-used.\n\nUnnamed queries, with `:name` equal to `\"\"`, are automatically closed\nafter being executed.","ref":"MyXQL.Queries.html#module-named-and-unnamed-queries"},{"type":"type","title":"MyXQL.Queries.t/0","doc":"","ref":"MyXQL.Queries.html#t:t/0"},{"type":"module","title":"MyXQL.Query","doc":"A struct for a prepared statement that returns a single result.\n\nFor the struct returned from a query that returns multiple\nresults, see `MyXQL.Queries`.\n\nIts public fields are:\n\n  * `:name` - The name of the prepared statement;\n  * `:num_params` - The number of parameter placeholders;\n  * `:statement` - The prepared statement","ref":"MyXQL.Query.html"},{"type":"module","title":"Named and Unnamed Queries - MyXQL.Query","doc":"Named queries are identified by the non-empty value in `:name` field\nand are meant to be re-used.\n\nUnnamed queries, with `:name` equal to `\"\"`, are automatically closed\nafter being executed.","ref":"MyXQL.Query.html#module-named-and-unnamed-queries"},{"type":"type","title":"MyXQL.Query.t/0","doc":"","ref":"MyXQL.Query.html#t:t/0"},{"type":"module","title":"MyXQL.Result","doc":"Result struct returned from any successful query.\n\nIts public fields are:\n\n  * `:columns` - The column names;\n  * `:connection_id` - The connection ID;\n  * `:last_insert_id` - The ID of the last inserted row;\n  * `:num_rows` - The number of fetched or affected rows;\n  * `:rows` - The result set. A list of lists, each inner list corresponding to a\n    row, each element in the inner list corresponds to a column;\n  * `:num_warnings` - The number of warnings","ref":"MyXQL.Result.html"},{"type":"module","title":"Warnings - MyXQL.Result","doc":"Depending on SQL MODE, a given query may error or just return warnings.\nIf `result.num_warnings` is non-zero it means there were warnings and they can be\nretrieved by making another query:\n\n    MyXQL.query!(conn, \"SHOW WARNINGS\")","ref":"MyXQL.Result.html#module-warnings"},{"type":"type","title":"MyXQL.Result.t/0","doc":"","ref":"MyXQL.Result.html#t:t/0"},{"type":"exception","title":"MyXQL.Error","doc":"","ref":"MyXQL.Error.html"},{"type":"type","title":"MyXQL.Error.t/0","doc":"","ref":"MyXQL.Error.html#t:t/0"},{"type":"extras","title":"MyXQL","doc":"# MyXQL\n\n[![CI](https://github.com/elixir-ecto/myxql/workflows/CI/badge.svg)](https://github.com/elixir-ecto/myxql/actions?query=workflow%3ACI)\n\nMySQL driver for Elixir.\n\nDocumentation:","ref":"readme.html"},{"type":"extras","title":"Features - MyXQL","doc":"* Automatic decoding and encoding of Elixir values to and from MySQL text and binary protocols\n  * Supports transactions, prepared queries, streaming, pooling and more via [DBConnection](https://github.com/elixir-ecto/db_connection)\n  * Supports MySQL 5.5+, 8.0, and MariaDB 10.3\n  * Supports `mysql_native_password`, `sha256_password`, and `caching_sha2_password`\n    authentication plugins","ref":"readme.html#features"},{"type":"extras","title":"Usage - MyXQL","doc":"Add `:myxql` to your dependencies:\n\n```elixir\ndef deps() do\n  [\n    {:myxql, \"~> 0.6.0\"}\n  ]\nend\n```\n\nMake sure you are using the latest version!\n\n```elixir\niex> {:ok, pid} = MyXQL.start_link(username: \"root\")\niex> MyXQL.query!(pid, \"CREATE DATABASE IF NOT EXISTS blog\")\n\niex> {:ok, pid} = MyXQL.start_link(username: \"root\", database: \"blog\")\niex> MyXQL.query!(pid, \"CREATE TABLE posts IF NOT EXISTS (id serial primary key, title text)\")\n\niex> MyXQL.query!(pid, \"INSERT INTO posts (`title`) VALUES ('Post 1')\")\n%MyXQL.Result{columns: nil, connection_id: 11204,, last_insert_id: 1, num_rows: 1, num_warnings: 0, rows: nil}\n\niex> MyXQL.query(pid, \"INSERT INTO posts (`title`) VALUES (?), (?)\", [\"Post 2\", \"Post 3\"])\n%MyXQL.Result{columns: nil, connection_id: 11204, last_insert_id: 2, num_rows: 2, num_warnings: 0, rows: nil}\n\niex> MyXQL.query(pid, \"SELECT * FROM posts\")\n{:ok,\n %MyXQL.Result{\n   columns: [\"id\", \"title\"],\n   connection_id: 11204,\n   last_insert_id: nil,\n   num_rows: 3,\n   num_warnings: 0,\n   rows: [[1, \"Post 1\"], [2, \"Post 2\"], [3, \"Post 3\"]]\n }}\n```\n\nIt's recommended to start MyXQL under supervision tree:\n\n```elixir\ndefmodule MyApp.Application do\n  use Application\n\n  def start(_type, _args) do\n    children = [\n      {MyXQL, username: \"root\", name: :myxql}\n    ]\n\n    Supervisor.start_link(children, opts)\n  end\nend\n```\n\nand then we can refer to it by its `:name`:\n\n```elixir\niex> MyXQL.query!(:myxql, \"SELECT NOW()\").rows\n[[~N[2018-12-28 13:42:31]]]\n```","ref":"readme.html#usage"},{"type":"extras","title":"Mariaex Compatibility - MyXQL","doc":"See [Mariaex Compatibility](https://github.com/elixir-ecto/myxql/blob/master/MARIAEX_COMPATIBILITY.md) page for transition between drivers.","ref":"readme.html#mariaex-compatibility"},{"type":"extras","title":"Data representation - MyXQL","doc":"```\nMySQL                Elixir\n-----                ------\nNULL                 nil\nbool                 1 | 0\nint                  42\nfloat                42.0\ndecimal              #Decimal  # (1)\ndate                 ~D[2013-10-12] # (2)\ntime                 ~T[00:37:14]   # (3)\ndatetime             ~N[2013-10-12 00:37:14]  # (2), (4)\ntimestamp            ~U[2013-10-12 00:37:14Z] # (2), (4)\njson                 %{\"foo\" => \"bar\"} # (5)\nchar                 \"é\"\ntext                 \"myxql\"\nbinary                >\nbit                   >\npoint, polygon, ...  %Geo.Point{coordinates: {0.0, 1.0}}, ... # (6)\n```\n\nNotes:\n\n1. See [Decimal](https://github.com/ericmj/decimal)\n\n2. When using SQL mode that allows them, MySQL \"zero\" dates and datetimes are represented as `:zero_date` and `:zero_datetime` respectively.\n\n3. Values that are negative or greater than `24:00:00` cannot be decoded\n\n4. Datetime fields are represented as `NaiveDateTime`, however a UTC `DateTime` can be used for encoding as well\n\n5. MySQL added a native JSON type in version 5.7.8, if you're using earlier versions,\nremember to use TEXT column for your JSON field.\n\n6. See \"Geometry support\" section below","ref":"readme.html#data-representation"},{"type":"extras","title":"JSON support - MyXQL","doc":"MyXQL comes with JSON support via the [Jason](https://github.com/michalmuskala/jason) library.\n\nTo use it, add `:jason` to your dependencies:\n\n```elixir\n{:jason, \"~> 1.0\"}\n```\n\nYou can customize it to use another library via the `:json_library` configuration:\n\n```elixir\nconfig :myxql, :json_library, SomeJSONModule\n```","ref":"readme.html#json-support"},{"type":"extras","title":"Geometry support - MyXQL","doc":"MyXQL comes with Geometry types support via the [Geo](https://github.com/bryanjos/geo) package.\n\nTo use it, add `:geo` to your dependencies:\n\n```elixir\n{:geo, \"~> 3.3\"}\n```\n\nNote, some structs like `%Geo.PointZ{}` does not have equivalent on the MySQL server side and thus\nshouldn't be used.\n\nIf you're using MyXQL geometry types with Ecto and need to for example accept a WKT format as user\ninput, consider implementing an [custom Ecto type](https://hexdocs.pm/ecto/Ecto.Type.html).","ref":"readme.html#geometry-support"},{"type":"extras","title":"Contributing - MyXQL","doc":"Run tests:\n\n```\ngit clone git@github.com:elixir-ecto/myxql.git\ncd myxql\nmix deps.get\nmix test\n```\n\nSee [`scripts/test-versions.sh`](scripts/test-versions.sh) for scripts used to test against different server versions.","ref":"readme.html#contributing"},{"type":"extras","title":"License - MyXQL","doc":"The source code is under Apache License 2.0.\n\nCopyright (c) 2018 Plataformatec \\\nCopyright (c) 2020 Dashbit\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at [http://www.apache.org/licenses/LICENSE-2.0](http://www.apache.org/licenses/LICENSE-2.0)\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"readme.html#license"}],"content_type":"text/markdown"}